$regfile = "m168pdef.dat"
$crystal = 8000000
'================================================PORTB================================================
Config Portb.0 = Output                                     'dwukropek wywietlacza
Config Portb.1 = Output                                     'wyjcie PWM
Config Portb.2 = Output                                     'wyjcie PWM
Config Portb.3 = Output                                     'wyjcie sterowania zaczaniem transformatora mocy
Config Portb.4 = Output                                     'wyjcie sterowania przekanika zaczajcego akumulator
Config Portb.5 = Output                                     'wyjcie sterowania prac sterownika TL494

Config Sda = Portb.6                                        'SDA
Config Scl = Portb.7                                        'SCL
'================================================PORTC================================================
'Config Portc.0 = Input                                      'wejcie ADC pomiaru napicia na akumulatorze
'Config Portc.1 = Input                                      'wejcie ADC pomiar prdu adowania
'Config Portc.2 = Input                                      'wejcie ADC pomiar napicia na mostku prostowniczym

Config 1wire = Portc.3                                      'wejscie czujnika temperatury otoczenia

Config Portc.4 = Output                                     'wyjcie sterowania T1
Config Portc.5 = Output                                     'wyjcie sterowania T2
'================================================PORTD================================================
Config Portd.0 = Output                                     'wyjcie sterowania T3
Config Portd.1 = Output                                     'wyjcie sterowania T4
Config Portd.2 = Input                                      'wejcie biegunowoci "biegunowo prawidowa"
Config Portd.3 = Input                                      'wejcie biegunowoci "biegunowo odwrotna"
Config Portd.4 = Input                                      'wejcie impulsatora
Config Portd.5 = Input                                      'wejcie ukadu zegara PCF8583
Config Portd.6 = Input                                      'wejcie impulsatora
Config Portd.7 = Input                                      'wejcie przycisku impulsatora
'===============================================TIMER 0===============================================
Config Timer0 = Timer , Prescale = 64                       'konfiguracja timera jako timer
On Timer0 Mult_wysw                                         'z podziaem przez 64
'===============================================TIMER 1===============================================
Config Timer1 = Pwm , Pwm = 10 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Prescale = 64
'konfiguracja timera jako dwukanaowy generator PWM z podziaem przez 64
'==============================================WATCHDOG===============================================
Config Watchdog = 2048
'=================================================ADC=================================================
Config Adc = Single , Prescaler = Auto , Reference = Off    'konfiguracja przetwornika A/D podzia
                 'czstotliwoci automatyczny i wsppraca z zewntrzym rdem napicia odniesienia
'===============================================ZMIENNE===============================================
Dim Nr_wysw As Byte , U1 As Byte , U2 As Byte , U3 As Byte , U4 As Byte , U As Word , U_sin As Single
Dim I1 As Byte , I2 As Byte , I3 As Byte , I4 As Byte , I As Word
Dim Ur As Single , Ir As Single , Licznik_prostownika As Byte
Dim Q1 As Byte , Q2 As Byte , Q3 As Byte , Q4 As Byte , Q As Word
Dim Qzm1 As Byte , Qzm2 As Byte , Qzm3 As Byte , Qzm4 As Byte , Qzm As Word
Dim Qzm_pomoc As Long , Qzm_pomoc_2 As Single
Dim Led_y As Byte , Wysw As Word , Wysw_pomoc As Word
Dim Pcf As Byte , Qq As Single , Vv As Single
Dim Tryb As Byte , Plus As Bit , Minus As Bit , Flaga_zezw As Bit , Licznik_sw As Word , Power_on As Bit
Dim Minuty As Byte , Godziny As Byte , Pomoc_mm As Byte , Pomoc_gg As Byte , Odczyt_zapis As Bit
Dim S As Byte , M As Byte , H As Byte , Mm_pomoc As Byte , Gg_pomoc As Byte
Dim Auto_powrot As Word , Blad_ladowania As Bit , Licznik_prad As Byte
Dim Licznik_petli As Byte , Licznik_migaj As Byte , Migaj As Bit , Licz As Word
Dim Napiecie As Word , Prad As Word , Napiecie_prostownika As Word , Temperatura As Word
Dim Napiecie_suma As Word , Prad_suma As Word
Dim Napiecie_single As Single , Prad_single As Single , Odczyt_pamieci As Bit
Dim T As Single , T1 As Single , T2 As Single , T3 As Single
Dim Detektor_error As Bit , Pr_error As Bit , Aku_v As Bit , 6v As Bit , 12v As Bit , 24v As Bit
Dim Ladowanie As Bit , Naladowany As Bit , Pwm_a As Word , Pwm_b As Word
Dim Ustawienia As Byte , Licznik_erom As Byte , Opuznienie As Word , Pomiar As Bit , Flaga_pomiar As Bit
Dim Auto_wylacz As Word , Licznik_naladowany As Word , Flaga_naladowany As Bit
'================================================STAE================================================
Const Urr = 1.12                                            'dla 7,2V:14,4V:28,8V
Const Irr = 0.83                                            'dla 75% prdu adowania
'===============================================ALIASY================================================
W1 Alias Portc.4
W2 Alias Portc.5
W3 Alias Portd.0
W4 Alias Portd.1
Trafo Alias Portb.3
Aku Alias Portb.4
Tl494 Alias Portb.5
Dwukropek Alias Portb.0

Start Adc
'===============================ODCZYT ZMIENNEJ USTAWIENIA Z PAMICI EEPROM'==========================
Readeeprom Ustawienia , 2                                   'odczytaj warto bitw ustawionych podczas niedokoczonego procesu adowania
Odczyt_pamieci = Ustawienia.5                               'przepisz warto bitu naadowany
'==========ODCZYT PAMICI PO PRZERWANYM PROCESIE ADOWANIA Z POWODU PRZERWY W DOSTAWIE PRDU==========
If Odczyt_pamieci = 1 And Pind.2 = 0 Then                   'gdy akumulator nie zosta naadowany i jaes podczony do adowarki
   Naladowany = Ustawienia.0                                'przepisz warto bitu naadowany
     'Readeeprom Qzm_pomoc , 3
   Ladowanie = Ustawienia.1
   6v = Ustawienia.2                                        'przepisz wartoi bitw napicia adowanego akumulatora
   12v = Ustawienia.3
   24v = Ustawienia.4
   Readeeprom T1 , 7                                        'odczyt wartoci temperatury T1
   Readeeprom T2 , 11                                       'odczyt wartoci temperatury T2
   Readeeprom T3 , 15                                       'odczyt wartoci temperatury T3
   Licznik_petli = 181                                      'po odczytaniu wartoci skocz odrazu do 190
   Licznik_erom = 181                                       'wpisanie wartoci pocztkowej
   Licznik_prostownika = 19
   Power_on = 1                                             'wcz adowark
   Aku_v = 1                                                'ustaw flag prawidowego podczenia
   Auto_wylacz = 0                                          'zwruj licznik automatycznego wyczenia adowarki
   Naladowany = 0                                           'zeruj flag
   Licznik_naladowany = 0                                   'zeruj licznik penego naadowania
   Flaga_naladowany = 0
End If
'==========================================WCZENIE PRZERWA=========================================
Enable Interrupts                                           'wczenie przerwa globalnych

Enable Timer0                                               'wczenie przerwanie od timera 0

Start Timer0                                                'start timerw odliczajcych czas oraz ukadu watchdog
Start Watchdog
'==========================================NIESKOCZONA PTLA=========================================
Do
  If Flaga_zezw = 1 Then                                    'gdy flaga ustawiona wykonuj instrukcj
     If Power_on = 0 Then                                   'stan czuwania
        U = 0                                               'zeruj zmienn napicia
        I = 0                                               'zeruj zmienn prdu
        Licznik_naladowany = 0                              'zeruj licznik penego naadowania
        Flaga_naladowany = 0
        Trafo = 0                                           'wyczone zasilanie transformatora gwnego
        Licznik_petli = 0                                   'zeruj licznik aby po wyjciu ze stanu czuwania zaczyna od pocztku
        Licznik_erom = 185
        Licznik_prostownika = 19
        Aku = 0                                             'przekanik akumulatora wyczony
        Tl494 = 1                                           'sterownik przetwornicy wyczony
        Pwm1a = 0                                           'zadany prd rwny zero
        Pwm1b = 0                                           'zadane napicie rwne zero
        If Pind.7 = 0 Then
           Incr Licznik_sw                                  'zwikszaj zawarto zmiennej gdy przycisk impulsatora jest wcisnity
           If Licznik_sw > 500 Then : Odczyt_zapis = 1 : Licznik_sw = 0 : End If       'dugie nacinicie przycisku impulsatora i puszczenie go powoduje ustawienie flagi
        Else
           If Licznik_sw > 100 And Licznik_sw < 300 Then
              Licznik_sw = 0
              Set Power_on                                  'trzymanie przycisku ustaw flag wczenia zasilania
           End If
        End If
        If Odczyt_zapis = 0 Then                            'odczyt czasu
           If Pind.5 = 1 Then
              Dwukropek = 1
           Else
              Dwukropek = 0
           End If                                           'dwukropek miga w rytm sygnau z zegara PCF
                                                            'ustaw flag licz aby zezwoli na obliczanie pojemnoci wadowanej
                                                            'zwiksza stan licznika w rytm sygnau
        Else                                                'zapis czasu do zegara
           Set Dwukropek                                    'podczas ustawiania czasu dwukropek wieci wiatem cigym
           Incr Auto_powrot                                 'zwiekszaj zawarto licznika automatycznego powrotu
           '////////////////////////////////////ZWIKSZA///////////////////
           If Plus = 1 Then                                 'ustawianie czasu  w gr
              Incr Mm_pomoc
              If Mm_pomoc > 59 Then
                 Mm_pomoc = 0
                 Incr Gg_pomoc
                 If Gg_pomoc > 23 Then
                    Gg_pomoc = 0
                 End If
              End If
              Auto_powrot = 0                               'zeruj licznik automatycznego ;powrotu
           End If
           '////////////////////////////////////ZMNIEJSZA//////////////////
           If Minus = 1 Then                                'ustawianie czasu w d
              Decr Mm_pomoc
              If Mm_pomoc = 255 Then
                 Mm_pomoc = 59
                 Decr Gg_pomoc
                 If Gg_pomoc = 255 Then
                    Gg_pomoc = 59
                 End If
              End If
              Auto_powrot = 0                               'zeruj licznik automatycznego ;powrotu
           End If
           If Auto_powrot > 1000 Then                       'po 10s wracaj do wywiatlania aktualnego czasu
              Odczyt_zapis = 0                              'zeruj licznik
              Auto_powrot = 0                               'zeruj licznik
           End If
        End If
     Else                                                   'stan pracy adowarki
        Trafo = 1                                           'wczone zasilanie transformatora gwnego
        Dwukropek = 0                                       'wyga dwukropek
        If Pind.7 = 0 Then
           Incr Licznik_sw                                  'zwikszaj zawarto zmiennej gdy przycisk impulsatora jest wcisnity
           If Licznik_sw > 100 And Licznik_sw < 300 Then
              Ustawienia.5 = 0                              'kasuj bit odczytu pamici
              Writeeeprom Ustawienia , 2                    'zapisz do pamieci
              Reset Power_on                                'po 5s trzymania przycisku zeruj flag wczenia zasilania
              Licznik_sw = 0
           End If
        End If

        Incr Licznik_migaj                                  'zwikszaj stan licznika

        If Licznik_petli < 190 Then : Incr Licznik_petli : Else : Licznik_petli = 190 : End If       'zwiksz o jeden zawarto licznika ptli gdy jest mniejszy od 190
        If Licznik_migaj = 100 Then                         'co 1s zmieniaj stan zmiennej migaj
           Toggle Migaj
           Set Flaga_pomiar                                 'ustaw flag zazwa;ajc na pomiar napicia i prdu
           Licznik_migaj = 0
        End If

        Select Case Licznik_petli                           'instrukcja wyboru zalena od zmiennej licznik_ptli
          Case 5:
             Odczyt_pamieci = 0                             'zeruj flag odczytu zawartoci pamieci
             Auto_wylacz = 0                                'zwruj licznik automatycznego wyczenia adowarki
             Naladowany = 0                                 'zeruj flag
             Licznik_naladowany = 0                         'zeruj licznik penego naadowania
             Flaga_naladowany = 0
             Napiecie_suma = 0
             Prad_suma = 0
             U = 0                                          'zeruj wskazania wywietlaczy
             I = 0
             Q = 0
             Qzm = 0                                        'zeruj liczniki pojemnoci zmieonej
             Qzm_pomoc = 0
             Qzm_pomoc_2 = 0
             If Pind.2 = 0 Then                             'prawidowo podczony akumulator do adowarki
                Aku = 1                                     'przekanik wczony
                Aku_v = 1                                   'ustaw flag prawidowego podczenia
                Detektor_error = 0                          'zeruj flag gdy detektor dziaa prawidowo
                Qzm = 0                                     'zeruj liczniki pojemnoci zmieonej
                Qzm_pomoc = 0
                Qzm_pomoc_2 = 0
             End If
             If Pind.3 = 0 Then                             'nieprawidowe podczenie akumulatora do adowarki
                Aku = 0                                     'przekanik wyczony
                Aku_v = 0                                   'zeruj flag prawidowego podczenia
                Detektor_error = 0                          'zeruj flag gdy detektor dziaa prawidowo
             End If
             If Pind.2 = 0 And Pind.3 = 0 Then              'awaria ukadu detekcji
                Aku = 0                                     'przekanik wyczony
                Aku_v = 0                                   'zeruj flag prawidowego podczenia
                Detektor_error = 1                          'ustaw flag aby migay lampki "biegunowo" i "error"
             End If
             If Pind.2 = 1 And Pind.3 = 1 Then              'akumulator nie zosta podczony do adowarki
                Aku = 0                                     'przekanik wyczony
                Aku_v = 0
                Detektor_error = 0                          'zeruj flag gdy detektor dziaa prawidowo
                Licznik_petli = 0                           'zeruj licznik aby zatrzyma program a do czasu podczenia akumulatora
             End If
          Case 10:                                          'po 100ms komunikacja z ukadem DS1820
             Disable Interrupts
                1wreset
                1wwrite &HCC
                1wwrite &H44
             Enable Interrupts
          Case 17:
             Napiecie = Getadc(0)                           'pomiar napiecia i odrzucenie pierwszych bdnych pomiarw
          Case 20:                                          'po 200ms odczyt napicia na akumulatorze
             Napiecie = Getadc(0)                           'i decyzja z jaki akumulator jest podpity do adowarki
             If Napiecie > 125 And Napiecie < 200 Then : 6v = 1 : 12v = 0 : 24v = 0 : End If       'przedzia od 5V do 8V akumulator 6Voltowy
             If Napiecie > 250 And Napiecie < 400 Then : 6v = 0 : 12v = 1 : 24v = 0 : End If       'przedzia od 10V do 16V akumulator 12Voltowy
             If Napiecie > 500 And Napiecie < 800 Then : 6v = 0 : 12v = 0 : 24v = 1 : End If       'przedzia od 20V do 32V akumulator 24Voltowy
             If Napiecie < 125 Or Napiecie > 800 Then : 6v = 0 : 12v = 0 : 24v = 0 : End If       'poza zakresem
             If Napiecie > 200 And Napiecie < 250 Then : 6v = 0 : 12v = 0 : 24v = 0 : End If       'midzyzakresy
             If Napiecie > 400 And Napiecie < 500 Then : 6v = 0 : 12v = 0 : 24v = 0 : End If       'midzyzakresy
             If 6v = 1 Then                                 'gdy wykryto akumulator 6v a jego napicie zawiera
                If Napiecie > 122 And Napiecie < 150 Then Ladowanie = 1       'si pomidzy 5v a 6,15v ustaw flag "LADOWANIE" adowanie
                If Napiecie > 150 And Napiecie < 194 Then Ladowanie = 0       'si pomidzy 6,15v a 8v zeruj flag "LADOWANIE" doadowanie
             End If
             If 12v = 1 Then                                'gdy wykryto akumulator 12v a jego napicie zawiera
                If Napiecie > 244 And Napiecie < 300 Then Ladowanie = 1       'si pomidzy 10v a 12,3v ustaw flag "LADOWANIE" adowanie
                If Napiecie > 300 And Napiecie < 388 Then Ladowanie = 0       'si pomidzy 12,3v a 16v zeruj flag "LADOWANIE" doadowanie
             End If
             If 24v = 1 Then                                'gdy wykryto akumulator 24v a jego napicie zawiera
                If Napiecie > 488 And Napiecie < 600 Then Ladowanie = 1       'si pomidzy 20v a 24,6v ustaw flag "LADOWANIE" adowanie
                If Napiecie > 600 And Napiecie < 776 Then Ladowanie = 0       'si pomidzy 24,6v a 32v zeruj flag "LADOWANIE" doadowanie
             End If
             U_sin = Napiecie * 4.17                        'wywietlenie zmieonego napicia
             U = Int(u_sin)
             Q = 10                                         'po odczytaniu napicia akumulatora ustaw warto pocztkow pojemnoci
             Aku = 0                                        'wycz przekanik po zmierzenu napicia

          Case 95:                                          'po 750ms odczyt temperatury otoczenia
             Disable Interrupts
             1wreset
             1wwrite &HCC
             1wwrite &HBE
             Temperatura = 1wread(2)
             Temperatura = Temperatura Or 65536             'maskowanie
             T = Temperatura / 16                           'odczyt temperatury
             1wreset
             If Err = 1 Then                                'jeli jest bd w komunikacji z termometrem
                Set Detektor_error
                T1 = 0
                T2 = 0
                T3 = 0
             Else                                           'nie ma bdu
                Reset Detektor_error
                T1 = 20 - T                                 'odejmnij od 20oC temperatur zmnierzon aby otrzyma ujemny wspczynnik korekcji napicia
                T2 = T1 * 0.5                               'podziel t1 przez dwa dla wspczynnika 24mV/1oC
                T3 = T1 * 0.25                              'podziel t1 przez cztery dla wspczynnika 12mV/1oC
             End If
             Writeeeprom T1 , 7                             'zapis wartoci temperatury T1
             Writeeeprom T2 , 11                            'zapis wartoci temperatury T2
             Writeeeprom T3 , 15                            'zapis wartoci temperatury T3
             Enable Interrupts
             Licznik_erom = 185                             'wpisanie wartoci pocztkowej

          Case 185:
             If Odczyt_pamieci = 1 Then
                Readeeprom Q , 19                           'odczyt wartoci zadanej pojemnoci
             End If
             Flaga_pomiar = 0

          Case 190:                                         'po 1,9s i uprzednim ustaleniu poszczegulnych wartoci rozpocznij proces adowania
             If Flaga_pomiar = 1 Then                       'co 1s pomiar napi i prdw
                If Pomiar = 1 Then
                   Napiecie = Getadc(0)                     'przepisanie zawartoci przetwornikw a/d do zmiennych prdu i napicia adowania
                   Prad = Getadc(1)
                   U_sin = Napiecie * 4.17                  'obliczenia prdu adowania i napicia aby wywietli je prawidowo na wyswietlaczach
                   U = Int(u_sin)                           'urednianie wyniku pomiarw dla stabilizacji wskaza
                   I = Prad * 2
                Else
                   I = 0
                End If
                Napiecie_prostownika = Getadc(2)            'odczyt napicia za prostownikem
                If Napiecie_prostownika < 575 Then : Pr_error = 1 : Licznik_prostownika = 0 : End If       'jeli napicie na prostowniku i przed stabilizatorem
                                                              'u1 spadnie ustaw flag pr_error oznaczajc
                                                              'awarj w ukadzie zasilania adowarki
                If Napiecie_prostownika > 590 Then          'u1 spadnie ustaw flag pr_error oznaczajc
                   Incr Licznik_prostownika                 'awarj w ukadzie zasilania adowarki
                   If Licznik_prostownika > 18 Then         'wprowadz opunienie i przez ok.20s sygnalizuj bd przecienia
                      Pr_error = 0                          'adowarki
                      Licznik_prostownika = 19
                   End If
                End If                                      'jeli napicie na prostowniku i przed stabilizatorem
                                                              'u1 spadnie ustaw flag pr_error oznaczajc
                                                              'awarj w ukadzie zasilania adowarki
                Reset Flaga_pomiar
             End If

             Incr Licznik_erom                              'zwikszaj stan licznika
             If Licznik_erom > 190 Then Licznik_erom = 190

             Select Case Licznik_erom
             Case 180:                                      'zapisz dane w pamici nieulotnej
                Set Odczyt_pamieci                          'ustaw flag odczytu pamici przy kadej zmianie ustawie
                Ustawienia.0 = Naladowany                   'przepisz warto bitu naadowany
                Ustawienia.1 = Ladowanie                    'przepisz warto bitu adowanie
                Ustawienia.2 = 6v                           'przepisz wartoi bitw napicia adowanego akumulatora
                Ustawienia.3 = 12v
                Ustawienia.4 = 24v
                Ustawienia.5 = Odczyt_pamieci
                Writeeeprom Ustawienia , 2                  'zapisz warto warznych bitw ustawie adowania
                Writeeeprom Q , 19                          'zapisz zadan pojemno
             Case 190:
                If Q > 10 Then                              'gdy akumulator zosta podpity do adowarki i zosta nastawiony prd adowania
                   Incr Opuznienie                          'zwikszaj licznik opunienia zaczania przekanika
                   If Opuznienie > 1000 Then : Aku = 1 : Set Pomiar : Else : Aku = 0 : Reset Pomiar : End If
                   Led_y.6 = 1                              'zga lampk "STOP"
                   Tl494 = 0                                'wcz sterownik przetwornicy
                   '///////////////////////////////////////////////////////////////////////
                   If 6v = 1 Then                           'wpisz wartoci dla 6v
                      If Ladowanie = 1 Then                 'tryb adowania
                         Qq = Q / 2.25
                      Else                                  'tryb doadowania
                         Qq = Q / 4.5                       'prd o poowe mniejszy
                      End If

                      If Opuznienie > 1500 Then             'kontrola tylko jak jest adowany akumulator
                         Opuznienie = 1500
                         If Napiecie < 125 Then Licznik_petli = 0       'gdy podczas adowania napicie spadnie poniej 5V oznacza zwarcie kasuj licznik i zacznij program od pocztku
                      End If

                      If Naladowany = 0 Then                'adowanie akumulatora
                         Led_y.7 = 0                        'zapal lampk "START"
                                                '7,5v - 12mV/1oC korekcja temperaturowa
                         Vv = 154 + T3
                      Else                                  'naadowany
                         If Migaj = 1 Then : Led_y.7 = 1 : Else : Led_y.7 = 0 : End If       'lampka "START" miga
                                                   '6,75v - 12mV/1oC korekcja temperaturowa
                         Vv = 142 + T3
                      End If
                   End If
                   '///////////////////////////////////////////////////////////////////////
                   If 12v = 1 Then                          'wpisz wartoci dla 12v
                      If Ladowanie = 1 Then                 'tryb adowania
                         Qq = Q / 2.25
                      Else                                  'tryb doadowania
                         Qq = Q / 4.5                       'prd o poowe mniejszy
                      End If

                      If Opuznienie > 1500 Then             'kontrola tylko jak jest adowany akumulator
                         Opuznienie = 1500
                         If Napiecie < 250 Then Licznik_petli = 0       'gdy podczas adowania napicie spadnie poniej 10V oznacza zwarcie kasuj licznik i zacznij program od pocztku
                      End If

                      If Naladowany = 0 Then                'adowanie akumulatora
                         Led_y.7 = 0                        'zapal lampk "START"
                                               '15v - 24mV/1oC korekcja temperaturowa
                         Vv = 308 + T2
                      Else                                  'naadowany
                         If Migaj = 1 Then : Led_y.7 = 1 : Else : Led_y.7 = 0 : End If       'lampka "START" miga
                                               '13,5v - 24mV/1oC korekcja temperaturowa
                         Vv = 284 + T2
                      End If
                   End If
                   '///////////////////////////////////////////////////////////////////////
                   If 24v = 1 Then                          'wpisz wartoci dla 24v
                      If Ladowanie = 1 Then                 'tryb adowania
                         Qq = Q / 2.25
                      Else                                  'tryb doadowania
                         Qq = Q / 4.5                       'prd o poowe mniejszy
                      End If

                      If Opuznienie > 1500 Then             'kontrola tylko jak jest adowany akumulator
                         Opuznienie = 1500
                         If Napiecie < 500 Then Licznik_petli = 0       'gdy podczas adowania napicie spadnie poniej 20V oznacza zwarcie kasuj licznik i zacznij program od pocztku
                      End If

                      If Naladowany = 0 Then                'adowanie akumulatora
                         Led_y.7 = 0                        'zapal lampk "START"
                                               '30v - 48mV/1oC korekcja temperaturowa
                         Vv = 616 + T1
                      Else                                  'naadowany
                         If Migaj = 1 Then : Led_y.7 = 1 : Else : Led_y.7 = 0 : End If       'lampka "START" miga
                                              '27v - 48mV/1oC korekcja temperaturowa
                         Vv = 568 + T1
                      End If
                   End If
                   '///////////////////////////////////NAADOWANY/////////////////////////
                   Napiecie_single = Napiecie               'przepisanie zmiennej word do single
                   Prad_single = Prad                       'przepisanie zmiennej word do single
                   Ur = Napiecie_single / Vv                'obliczenia stosunku napicia zadanego do adowanego
                   Ir = Prad_single / Qq                    'obliczenia stosunku prdu adowania do pojemnoci zadanej
                   '//////////////////////////////////////////////////////////////////////
                   If Naladowany = 0 Then                   'licz wadowan pojemno tylko podczas procesu adowania
                                                             'adowanie
                      If Ur > Urr And Ir < Irr Then : Set Flaga_naladowany : Else : Reset Flaga_naladowany : End If
                                                             'oznaki penego naadowania
                      If Pind.5 = 0 Then                    'sprawdzaj stan na wyjciu z zegara PCF
                         Incr Licz
                         If Licz = 10 Then                  'gdy licznik osigno warto 10
                            If Flaga_naladowany = 1 Then
                               Incr Licznik_naladowany      'zwikszaj licznik penego naadowania
                               If Licznik_naladowany > 9 Then       'po 10sek po oznakach penego naadowania
                                  Opuznienie = 0            'na chwil wycz przekanik aby podtrzyma przepyw prdu
                                  Naladowany = 1            'przecz adowark na prac konserwujc akumulator
                                  Licznik_naladowany = 0    'zeruj licznik penego naadowania
                               End If
                            Else
                               Licznik_naladowany = 0
                            End If
                            If Prad = 0 And Opuznienie = 1500 Then       'gdy zostanie odczony akumulator
                               Incr Licznik_prad
                               If Licznik_prad > 29 Then    'po 30 sekundach zaczynaj od nowa
                                  Licznik_petli = 0
                                  Licznik_prad = 30
                               End If
                            Else
                               Licznik_prad = 0
                            End If
                            Qzm_pomoc = Qzm_pomoc + Prad    'co 1s sumuj pomiary prdu adowania i zapisuj do zmiennej
                            Qzm_pomoc_2 = Qzm_pomoc / 18000 'obliczenia
                            Qzm = Int(qzm_pomoc_2)          'odrzucenie czci uamkowej
                         End If
                      Else
                         Licz = 0                           'zeruj licznik
                      End If
                   Else                                     'akumulator zosta naadowany
                      If Pind.5 = 0 Then                    'sprawdzaj stan na wyjciu z zegara PCF
                         Incr Licz
                         If Licz = 10 Then                  'gdy licznik osigno warto 10
                            Incr Auto_wylacz                'co 1s zwikszaj stan licznika
                            If Auto_wylacz > 1800 Then
                               Reset Odczyt_pamieci         'po ukoczeniu procesu adowania kasuj flag odczytu pamieci
                               Ustawienia.5 = Odczyt_pamieci       'przepisz warto bitu
                               Writeeeprom Ustawienia , 2   'i zapisz do pamici
                               Power_on = 0                 'oraz wycz adowark
                            End If
                         End If                             'po 30min po naadowaniu akumulatora wycz adowark
                      Else
                         Licz = 0                           'zeruj licznik
                      End If
                   End If

                   Pwm_a = Int(qq)                          'odrzu cz uamkow ze zmiennej qq i przepisz do pwm_a
                   Pwm1a = Pwm_a                            'przepisz zawarto zmiennej pwm_a do generatora pwm1a
                   Pwm_b = Int(vv)                          'odrzu cz uamkow ze zmiennej vv i przepisz do pwm_b
                   Pwm1b = Pwm_b                            'przepisz zawarto zmiennej pwm_b do generatora pwm1b
                Else                                        'gdy nie podpjty aden akululator
                   Pomiar = 0                               'nie dokonuj pomiarw i zeruj wskaniki prdu i napicia
                   Opuznienie = 0                           'kasuj licznik opuniena zaczania przekanika
                   Aku = 0                                  'wycz przekanik akumulatora
                   Led_y.3 = 1                              'zga lampk trybu adowania
                   Led_y.6 = 0                              'zapal lampk "STOP"
                   Led_y.7 = 1                              'zga lampk "START"
                   Tl494 = 1                                'sterownik przetwornicy wyczony
                   Pwm1a = 0                                'zadany prd rwny zero
                   Pwm1b = 0                                'zadane napicie adowania rwne zero
                End If

             End Select
        End Select                                          'koniec instrukcji wyboru zalenej od zmiennej licznik_ptli

        If Blad_ladowania = 1 Then                          'jeli flaga ustawiona miga lampka "error" oznacza przerwanie procesu adowania i uszkodzony akumulator
           If Migaj = 1 Then
              Led_y = 223
           Else
              Led_y = 255
           End If
        End If

        If Detektor_error = 1 Then                          'jeli flaga ustawiona jednoczenie migaj lamoki "error" i "biegunowo"
           If Migaj = 1 Then                                'oznacza to uszkodzenie detektora
              Led_y = 207
           Else
              Led_y = 255
           End If
        End If

        If Pr_error = 1 Then                                'jeli flaga ustawiona jednoczenie migaj lampki "error","6V","12V","24V"
           Q = 10                                           'zatrzymaj prac przetwornicy
           If Migaj = 1 Then                                'oznacza to awarj w ukadzie zasilania
              Led_y = 216
           Else
              Led_y = 255
           End If
        End If

        If Detektor_error = 0 And Pr_error = 0 Then
           If Aku_v = 1 Then                                'prawidowe podczenie akumulatora
              Led_y.4 = 1                                   'lampka "biegunowo" nie wieci
              If Ladowanie = 1 Then                         'tryb adowania
                 Led_y.3 = 0                                'lampka wieci wiatem cigym
              Else                                          'tryb doadowania
                 If Migaj = 1 Then : Led_y.3 = 1 : Else : Led_y.3 = 0 : End If       'lampka miga
              End If
              If 6v = 1 Then : Led_y.2 = 0 : Led_y.1 = 1 : Led_y.0 = 1 : Led_y.5 = 1 : End If       'zapal lampk 6V
              If 12v = 1 Then : Led_y.2 = 1 : Led_y.1 = 0 : Led_y.0 = 1 : Led_y.5 = 1 : End If       'zapal lampk 12V
              If 24v = 1 Then : Led_y.2 = 1 : Led_y.1 = 1 : Led_y.0 = 0 : Led_y.5 = 1 : End If       'zapal lampk 24V
              If 6v = 0 And 12v = 0 And 24v = 0 Then : Led_y.2 = 1 : Led_y.1 = 1 : Led_y.0 = 1 : Led_y.5 = 0 : End If
           Else                                             'pozazakresem lampki "6,12,24V" nie wiec lampka "error" wiweci
              Led_y.5 = 1                                   'lampka "error" nie wieci
              Led_y.2 = 1 : Led_y.1 = 1 : Led_y.0 = 1       'zga lampki "6,12,24V"
              Led_y.4 = 0                                   'nieprawidowe podczenie akumulatora zapal lampk "biegunowo"
              Led_y.3 = 1                                   'zga lampk trybu adowania
           End If
        End If
'=============ZWIKSZA============
     If Plus = 1 Then                                       'krco pokrtem w praw stron zwiksza si licznik pojemnoci akumulatora adowanego
        If 6v = 1 And 12v = 0 And 24v = 0 Then              'dla 6v
           If Q < 2001 Then                                 'gdy zadana pojemno nie wiksza jak 200,0Ah
              If Q =< 99 Then
                 Q = Q + 1
              Else
                 Q = Q + 10
                 If Q > 2000 Then Q = 2000
              End If
           End If
        End If

        If 6v = 0 And 12v = 1 And 24v = 0 Then              'dla 12v
           If Q < 1001 Then                                 'gdy zadana pojemno nie wiksza jak 100,0Ah
              If Q =< 99 Then
                 Q = Q + 1
              Else
                 Q = Q + 10
                 If Q > 1000 Then Q = 1000
              End If
           End If
        End If

        If 6v = 0 And 12v = 0 And 24v = 1 Then              'dla 24v
           If Q < 501 Then                                  'gdy zadana pojemno nie wiksza jak 50,0Ah
              If Q =< 99 Then
                 Q = Q + 1
              Else
                 Q = Q + 10
                 If Q > 500 Then Q = 500
              End If
           End If
        End If

        If 6v = 0 And 12v = 0 And 24v = 0 Then              'gdy nie podczono adnego akumulatora nie da si ustawi pojemnoci
           Q = 0
        End If
        Licznik_erom = 0                                    'zeruj licznik
     End If
'==============ZMNIEJSZA==========
     If Minus = 1 Then                                      'krcc pokrtem w lew stron zmniejsza si licznik pojemnoci akumulatora
        If 6v = 1 Or 12v = 1 Or 24v = 1 Then
           If Q >= 110 Then
              If Q >= 11 Then : Q = Q - 10 : End If
           Else
              If Q >= 11 Then : Q = Q - 1 : End If
           End If
        Else                                                'gdy nie podczono adnego akumulatora nie da si ustawi pojemnoci zadanej
           Q = 0
        End If
        Licznik_erom = 0                                    'zeruj licznik
     End If

     End If                                                 'zamknicie instrukcji warunkowej sprawdzajcej stan flagi POWER_ON

     Reset Watchdog                                         'zeruj licznik ukadu watchdoga
     Reset Plus                                             'zerowanie flagi ustawionej podczas krcenia enkoderem
     Reset Minus                                            'zarowanie flagi ustawionej podczas krcenia enkoderem
     Reset Flaga_zezw                                       'zerowanie flagi
  End If
Loop
End
'============================PODPROGRAMY OBSUGI PRZERWA OD TIMER 0==================================
Mult_wysw:                                                  'podprogram obsugi przerwania
  Select Case Nr_wysw
    Case 0:
'===============================================NAPICIE==============================================
      Reset W4
      Wysw = U                                              'wywietlacz napicia na akumulatorze
     Wysw_pomoc = Wysw Mod 10
      U1 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      U2 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      U3 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      U4 = Wysw_pomoc
     Wysw = Wysw / 10
       Pcf = Lookup(u4 , Tabela)
       If Power_on = 1 Then : I2csend &B01111000 , Pcf : Else : I2csend &B01111000 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W1
      Set Flaga_zezw

    Case 1:
      Reset W1
       Pcf = Lookup(u3 , Tabela_)
       If Power_on = 1 Then : I2csend &B01111000 , Pcf : Else : I2csend &B01111000 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W2

    Case 2:
      Reset W2
       Pcf = Lookup(u2 , Tabela)
       If Power_on = 1 Then : I2csend &B01111000 , Pcf : Else : I2csend &B01111000 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W3

    Case 3:
      Reset W3
       Pcf = Lookup(u1 , Tabela)
       If Power_on = 1 Then : I2csend &B01111000 , Pcf : Else : I2csend &B01111000 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W4

    Case 4:
'=================================================PRD================================================
      Reset W4
      Wysw = I                                              'wywietlanie prdu adowania akumulatora
     Wysw_pomoc = Wysw Mod 10
      I1 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      I2 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      I3 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      I4 = Wysw_pomoc
     Wysw = Wysw / 10
       Pcf = Lookup(i4 , Tabela)
       If Power_on = 1 And Naladowany = 0 Then : I2csend &B01111110 , Pcf : Else : I2csend &B01111110 , 255 : End If
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W1
      Set Flaga_zezw

    Case 5:
      Reset W1
       Pcf = Lookup(i3 , Tabela_)
       If Power_on = 1 And Naladowany = 0 Then : I2csend &B01111110 , Pcf : Else : I2csend &B01111110 , 255 : End If
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W2

    Case 6:
      Reset W2
       Pcf = Lookup(i2 , Tabela)
       If Power_on = 1 And Naladowany = 0 Then : I2csend &B01111110 , Pcf : Else : I2csend &B01111110 , 255 : End If
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W3

    Case 7:
      Reset W3
       Pcf = Lookup(i1 , Tabela)
       If Power_on = 1 And Naladowany = 0 Then : I2csend &B01111110 , Pcf : Else : I2csend &B01111110 , 255 : End If
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
       I2csend &B01110100 , 255
      Set W4

    Case 8:
'============================================POJEMNO ZM=============================================
      Reset W4
      Wysw = Qzm                                            'wywietlanie pojemnosci zadanej
     Wysw_pomoc = Wysw Mod 10
      Qzm1 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      Qzm2 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      Qzm3 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      Qzm4 = Wysw_pomoc
     Wysw = Wysw / 10
       Pcf = Lookup(qzm4 , Tabela)
       If Power_on = 1 Then : I2csend &B01110100 , Pcf : Else : I2csend &B01110100 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
      Set W1
      Set Flaga_zezw

    Case 9:
      Reset W1
       Pcf = Lookup(qzm3 , Tabela)
       If Power_on = 1 Then : I2csend &B01110100 , Pcf : Else : I2csend &B01110100 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
      Set W2

    Case 10:
      Reset W2
       Pcf = Lookup(qzm2 , Tabela_)
       If Power_on = 1 Then : I2csend &B01110100 , Pcf : Else : I2csend &B01110100 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
      Set W3

    Case 11:
      Reset W3
       Pcf = Lookup(qzm1 , Tabela)
       If Power_on = 1 Then : I2csend &B01110100 , Pcf : Else : I2csend &B01110100 , 255 : End If
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
       I2csend &B01110010 , 255
      Set W4

    Case 12:
      Reset W4
         If Odczyt_zapis = 0 Then                           'odczyt aktualnego czasu z zegara
            I2cstart                                        'odczyt aktualnego czasu
             I2cwbyte 160                                   'A0 = GND
             I2cwbyte 3                                     'rejestr minut
            I2cstart
             I2cwbyte 161                                   'adres odczytu
             I2crbyte Minuty , Ack
             I2crbyte Godziny , Nack
            I2cstop

            Minuty = Minuty And &B01111111                  'maskowanie
            Godziny = Godziny And &B00111111

            Pomoc_mm = Makedec(minuty)
            Pomoc_gg = Makedec(godziny)

            Gg_pomoc = Pomoc_gg
            Mm_pomoc = Pomoc_mm
         Else                                               'zapis czasu do zegara
            H = Makebcd(gg_pomoc)
            M = Makebcd(mm_pomoc)
            S = Makebcd(0)

            I2cstart
             I2cwbyte 160
             I2cwbyte 0                                     'rejestr kontrolny
             I2cwbyte 8                                     'ustawienie rejestru zapisu daty
            I2cstop
            I2cstart
             I2cwbyte 160
             I2cwbyte 2
             I2cwbyte S
             I2cwbyte M
             I2cwbyte H
            I2cstop
         End If

    Case 13:
'==============================================POJEMNO==============================================
      Reset W4
     If Power_on = 0 Then : Wysw = Mm_pomoc : Else : Wysw = Q : End If       'wywietlanie pojemnosci zadanej
     Wysw_pomoc = Wysw Mod 10
      Q1 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      Q2 = Wysw_pomoc
     Wysw = Wysw / 10

     If Power_on = 0 Then : Wysw = Gg_pomoc : End If
     Wysw_pomoc = Wysw Mod 10
      Q3 = Wysw_pomoc
     Wysw = Wysw / 10

     Wysw_pomoc = Wysw Mod 10
      Q4 = Wysw_pomoc
     Wysw = Wysw / 10
       Pcf = Lookup(q4 , Tabela)
       I2csend &B01110010 , Pcf
       I2csend &B01110100 , 255
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
      Set W1

    Case 14:
      Reset W1
       Pcf = Lookup(q3 , Tabela)
       I2csend &B01110010 , Pcf
       I2csend &B01110100 , 255
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
      Set W2

    Case 15:
      Reset W2
       If Power_on = 1 Then : Pcf = Lookup(q2 , Tabela_) : Else : Pcf = Lookup(q2 , Tabela) : End If
       I2csend &B01110010 , Pcf
       I2csend &B01110100 , 255
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
      Set W3

    Case 16:
      Reset W3
       Pcf = Lookup(q1 , Tabela)
       I2csend &B01110010 , Pcf
       I2csend &B01110100 , 255
       I2csend &B01111110 , 255
       I2csend &B01111000 , 255
      Set W4
      Set Flaga_zezw

    Case 17:                                                'obsuga lampek kontrolnych
      Reset W4
       I2csend &B01110000 , 255                             'najpierw wyga lampki
       If Power_on = 1 Then : I2csend &B01110000 , Led_y : Else : I2csend &B01110000 , 255 : End If       'wpisanie zawartoci zmiennej do expandera
  End Select
  Select Case Tryb
   Case 0:
    If Pind.6 = 1 And Pind.4 = 1 Then Incr Tryb             'jezeli enkoder nie jest obracany
   Case 1:
    If Pind.6 = 1 And Pind.4 = 0 Then Tryb = 2              'w zalenoci od kieruku obrotw
    If Pind.6 = 0 And Pind.4 = 1 Then Tryb = 3
   Case 2:
    If Pind.6 = 0 And Pind.4 = 1 Then
      Set Plus                                              'krcenie w lew stron powoduje ustawienie flago minus
      Tryb = 0
    End If
   Case 3:
    If Pind.6 = 1 And Pind.4 = 0 Then
      Set Minus                                             'krcenie w praw stron powoduje ustawienie flagi plus
      Tryb = 0
    End If
  End Select
  Incr Nr_wysw
  If Nr_wysw > 17 Then Nr_wysw = 0

Return

Tabela:
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255
Tabela_:
Data 64 , 121 , 36 , 48 , 25 , 18 , 2 , 120 , 0 , 16 , 255